version: '3'
services:
  #PHP Service
  app:
    build:
      context: .
      dockerfile: Dockerfile.dev
    container_name: portailva2-server

    networks:
      - db-network
      - web-network
    environment:
      # Keep attention to that env variable
      PHP_IDE_CONFIG: serverName=app
    depends_on:
      - db
    working_dir: /var/www
    volumes:
      - ./:/var/www
      # To override PHP config inside container
      - ./docker-config/local.ini:/usr/local/etc/php/conf.d/local.ini
      - ./docker-config/xdebug.ini:/usr/local/etc/php/conf.d/xdebug.ini
      - ./docker-config/xdebug.ini:/etc/php/conf.d/xdebug.ini

  #Nginx Service
  webserver:
    image: nginx:alpine
    container_name: portailva2-nginx
    ports:
      - "8080:8080"
    networks:
      - web-network
    depends_on:
      - app
    volumes:
      - ./:/var/www
      - ./docker-config/nginx/conf.d:/etc/nginx/conf.d

  #PostGreSQL Service
  db:
    image: postgres:latest
    container_name: portailva2-postgres
    ports:
      - "5432:5432"
    networks:
      - db-network
    environment:
      - POSTGRES_HOST_AUTH_METHOD=trust
      - POSTGRES_USER=${DB_USERNAME}
      - POSTGRES_PASSWORD=${DB_PASSWORD}
      - POSTGRES_DB=${DB_DATABASE}
    volumes:
      - ./docker-db:/var/lib/postgresql/data

  #Keycloak Service
  keycloak:
    image: jboss/keycloak:11.0.3
    container_name: keycloak
    ports:
      - "8090:8080"
    networks:
      - kc-db-network
    environment:
      - KEYCLOAK_USER=admin
      - KEYCLOAK_PASSWORD=admin
      - KEYCLOAK_IMPORT=/tmp/docker-config/keycloak/keycloak-realm.json
      - DB_VENDOR=postgres
      - DB_ADDR=keycloak-db
      - DB_PORT=5432
      - DB_USER=keycloak
      - DB_PASSWORD=keycloak
    volumes:
      - ./docker-config/keycloak:/tmp/docker-config/keycloak

  #Postgres service for keycloak
  keycloak-db:
    image: postgres:latest
    container_name: postgres-keycloak
    ports:
      - "5442:5432"
    networks:
      - kc-db-network
    environment:
      - POSTGRES_HOST_AUTH_METHOD=trust
      - POSTGRES_USER=keycloak
      - POSTGRES_PASSWORD=keycloak
      - POSTGRES_DB=keycloak
    volumes:
      - ./docker-db-keycloak:/var/lib/postgresql/data

#Docker Networks
networks:
  db-network: {}
  web-network: {}
  kc-db-network: {}

